import os
import subprocess
from tqdm import tqdm

# Ruta al ejecutable de Python
PYTHON_EXECUTABLE = r"C:\\Users\\USUARIO\\AppData\\Local\\Programs\\Python\\Python311\\python.exe"
MODULE = "-m"
SCRIPT = "code.run"

# Lista de clasificadores base a evaluar
base_models = ["xgboost", "random_forest", "decision_tree", "logistic_regression", "knn"]
# Lista de pipelines con distintas estrategias
pipelines = ["no_sampling", "oversampling", "oversampling_gridsearch", "downsampling", "cost_sensitive"]

for pipeline_name in pipelines:
    tqdm.write(f"Pipeline actual: {pipeline_name}")

    for model_name in base_models:
        if pipeline_name == "cost_sensitive" and model_name == "knn":
            tqdm.write(f"Saltando combinación incompatible: {pipeline_name} + {model_name}")
            continue

        tqdm.write(f"Ejecutando {pipeline_name} | Modelo: {model_name}")
        env = os.environ.copy()
        env["PIPELINE_NAME"] = pipeline_name
        env["MODEL_NAME"] = model_name

        subprocess.run([PYTHON_EXECUTABLE, MODULE, SCRIPT], env=env, check=True)